unit Unit1;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, dbf, db, FileUtil, Forms, Controls, Graphics, Dialogs,
  DBGrids, ExtCtrls, DbCtrls, Buttons, StdCtrls;

type

  { TForm1 }

  TForm1 = class(TForm)
    btnMembersPost: TBitBtn;
    btnMembersCancel: TBitBtn;
    btnGuitarsPost: TBitBtn;
    btnGuitarsCancel: TBitBtn;
    DBNavGuitars: TDBNavigator;
    DBNavMembers: TDBNavigator;
    edYear: TDBEdit;
    DBTextMemberID: TDBText;
    edBrand: TDBEdit;
    edType: TDBEdit;
    edKind: TDBEdit;
    dbfMembersID: TDbf;
    edLastname: TDBEdit;
    edFirstname: TDBEdit;
    dbfGuitars: TDbf;
    DBTextID: TDBText;
    dsMembers: TDataSource;
    dsGuitars: TDataSource;
    dbfMembers: TDbf;
    gridMembers: TDBGrid;
    gridGuitars: TDBGrid;
    panGuitars: TPanel;
    panMembers: TPanel;
    procedure btnGuitarsCancelClick(Sender: TObject);
    procedure btnGuitarsPostClick(Sender: TObject);
    procedure btnMembersCancelClick(Sender: TObject);
    procedure btnMembersPostClick(Sender: TObject);
    procedure dbfGuitarsAfterInsert(DataSet: TDataSet);
    procedure dbfGuitarsBeforeInsEdit(DataSet: TDataSet);
    procedure dbfMembersAfterInsert(DataSet: TDataSet);
    procedure dbfMembersBeforeInsEdit(DataSet: TDataSet);
    procedure FormDestroy(Sender: TObject);
    procedure FormShow(Sender: TObject);
  private
    procedure ShowHideUI;
  public

  end;

var
  Form1: TForm1;

implementation

{$R *.lfm}

{ TForm1 }

procedure TForm1.FormShow(Sender: TObject);
begin
  dbfMembers.Open;
  dbfGuitars.Open;
  panMembers.Hide;
  panGuitars.Hide;
end;

procedure TForm1.FormDestroy(Sender: TObject);
begin
  dbfGuitars.Close;
  dbfMembers.Close;
end;

procedure TForm1.dbfMembersBeforeInsEdit(DataSet: TDataSet);
begin
  panMembers.Show;
  ShowHideUI;
end;

procedure TForm1.dbfMembersAfterInsert(DataSet: TDataSet);
var
  IDNr: integer;
  ID: string;
begin
  dbfMembersID.Open;
  dbfMembersID.Last;
  IDNr := StrToInt(dbfMembersID.FieldByName('ID').AsString);
  ID := IntToStr(IDNr + 1);
  while Length(ID) < 4 do
    ID := '0' + ID;
  dbfMembers.FieldByName('ID').AsString := ID;
  dbfMembersID.Close;
end;

procedure TForm1.dbfGuitarsBeforeInsEdit(DataSet: TDataSet);
begin
  panGuitars.Show;
  ShowHideUI;
end;

procedure TForm1.dbfGuitarsAfterInsert(DataSet: TDataSet);
begin
  dbfGuitars.FieldByName('MEMBERID').AsString :=
    dbfMembers.FieldByName('ID').AsString;
end;

procedure TForm1.btnMembersPostClick(Sender: TObject);
begin
  if Trim(edLastname.Text) = '' then
    ShowMessage('Empty LASTNAME not allowed. Please correct.')
  else begin
    dbfMembers.Post;
    panMembers.Hide;
    ShowHideUI;
  end;
end;

procedure TForm1.btnMembersCancelClick(Sender: TObject);
begin
  dbfMembers.Cancel;
  panMembers.Hide;
  ShowHideUI;
end;

procedure TForm1.btnGuitarsPostClick(Sender: TObject);
begin
  if Trim(edBrand.Text) = '' then
    ShowMessage('Empty BRAND not allowed. Please correct.')
  else begin
    dbfGuitars.Post;
    panGuitars.Hide;
    ShowHideUI;
  end;
end;

procedure TForm1.btnGuitarsCancelClick(Sender: TObject);
begin
  dbfGuitars.Cancel;
  panGuitars.Hide;
  ShowHideUI;
end;

procedure TForm1.ShowHideUI;
begin
  gridMembers.Enabled := (not panMembers.Visible) and
                         (not panGuitars.Visible);
  gridGuitars.Enabled := gridMembers.Enabled;
  DBNavMembers.Enabled := gridMembers.Enabled;
  DBNavGuitars.Enabled := gridMembers.Enabled;
  if panMembers.Visible then
    edLastname.SetFocus
  else if panGuitars.Visible then
    edBrand.SetFocus
end;

end.

